#include "filepolynomutils.h"

int stringToInt (char * s){
    int i=0;
    int count = 1;
    int j,value;
    int res=0;
    while(s[i]!='\0')
        i++;
    for (j=i;j>0;j--){
        if(j!=1){
            value = s[j-1] - '0';
            res = res + value*count;
            count = count*10;
        }
        else{
            if(s[j-1]!='-'){
                value = s[j-1] - '0';
                res = res + value*count;
                count = count*10;
            }
            else{
                res=res*(-1);
            }
        }
    }
    return res;
}
bool isNumber(char c){
    bool res=false;
    if((c - '0')>=0 && (c - '0')<=9)
        res = true;
    return res;
}
bool isVar(char c){
    bool res=false;
    if(c=='X' || c=='Y')
        res = true;
    return res;
}
bool isSquare(char c){
    bool res=false;
    if(c=='^')
        res = true;
    return res;
}
bool isSpace(char c){
    bool res=false;
    if(c==' ')
        res = true;
    return res;
}
bool isAdd(char c){
    bool res=false;
    if(c=='+')
        res = true;
    return res;
}
long double evaluatePolynom(FILE * f,double x,double y){
    char c=getc(f);
    if(c==EOF)
        return NULL;
    long double result=0;
    bool found = false;
    bool found2 = false;
    bool eolFound = false;
    bool nextMonomial = false;
    bool eofFound = false;
    bool hasX = false;
    bool hasY = false;
    int i=0;
    char copia[256];
    char copia2[256];
    char copia3[256];
    while(!eolFound && !eofFound){
        i=0;
        found = false;
        found2 = false;
        eolFound = false;
        nextMonomial = false;
        hasX=false;
        hasY=false;
        while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
            if(isNumber(c)){
                copia[i]=c;
                i++;
                c=getc(f);
            }
        }
        copia[i]='\0';
        if(!isVar(c)){
           found=true;
        }
        if(found){
           result = result + stringToInt(copia);
        }
        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            nextMonomial=true;
        if(c==EOF)
            eofFound = true;
        i=0;
        if(c=='X'){
            c=getc(f);
            hasX=true;
            if(isSquare(c)){
                c=getc(f);
                while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
                  if(isNumber(c)){
                     copia2[i]=c;
                     i++;
                     c=getc(f);
                  }
               }
           }
        }
        copia2[i]='\0';
        if(!isVar(c) && !eolFound && !nextMonomial && !eofFound){
            found2 = true;
        }
        if(found2){
           result = result + (stringToInt(copia)*pow(x,stringToInt(copia2)));
        }
        i=0;
        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            nextMonomial=true;
        if(c==EOF)
            eofFound = true;
        if(c=='Y'){
            c=getc(f);
            hasY= true;
            if(isSquare(c)){
                c=getc(f);
                while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
                  if(isNumber(c)){
                     copia3[i]=c;
                     i++;
                     c=getc(f);
                  }
               }
           }
        }
        copia3[i]='\0';
        if(c==EOF)
            eofFound = true;
        if(!hasX && hasY && !eolFound && !nextMonomial){
            result = result + (stringToInt(copia)*pow(y,stringToInt(copia3)));
        }
        else if (hasX && hasY && !found2 && !eolFound && !nextMonomial){
            result = result + (stringToInt(copia)*pow(x,stringToInt(copia2))*pow(y,stringToInt(copia3)));
        }

        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            c=getc(f);
    }
    if(eofFound)
        ungetc(c,f);
    return result;
}


monomial evaluatePolynomX(FILE * f,double x){
    char c=getc(f);
    monomial res;
    int pos;
    if(c==EOF){
        res.setFlag(NULL);
        return res;
    }
    bool found = false;
    bool found2 = false;
    bool eolFound = false;
    bool nextMonomial = false;
    bool eofFound = false;
    bool hasX = false;
    bool hasY = false;
    int i=0;
    char copia[256];
    char copia2[256];
    char copia3[256];
    while(!eolFound && !eofFound){
        i=0;
        found = false;
        found2 = false;
        eolFound = false;
        nextMonomial = false;
        hasX=false;
        hasY=false;
        while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
            if(isNumber(c)){
                copia[i]=c;
                i++;
                c=getc(f);
            }
        }
        copia[i]='\0';
        if(!isVar(c)){
           found=true;
        }
        if(found){
           res.setIndependent(stringToInt(copia));
        }
        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            nextMonomial=true;
        if(c==EOF)
            eofFound = true;
        i=0;
        if(c=='X'){
            c=getc(f);
            hasX=true;
            if(isSquare(c)){
                c=getc(f);
                while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
                  if(isNumber(c)){
                     copia2[i]=c;
                     i++;
                     c=getc(f);
                  }
               }
           }
        }
        copia2[i]='\0';
        if(!isVar(c) && !eolFound && !nextMonomial && !eofFound){
            found2 = true;
        }
        if(found2){
           res.setIndependent(stringToInt(copia)*pow(x,stringToInt(copia2)));
        }
        i=0;
        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            nextMonomial=true;
        if(c==EOF)
            eofFound = true;
        if(c=='Y'){
            c=getc(f);
            hasY= true;
            if(isSquare(c)){
                c=getc(f);
                while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
                  if(isNumber(c)){
                     copia3[i]=c;
                     i++;
                     c=getc(f);
                  }
               }
           }
        }
        copia3[i]='\0';
        pos=stringToInt(copia3)-1;
        //copia3[i]='\0';
        if(c==EOF)
            eofFound = true;
        if(!hasX && hasY && !eolFound && !nextMonomial){
            res.setMonomial(pos,stringToInt(copia));
        }
        else if (hasX && hasY && !found2 && !eolFound && !nextMonomial){
            res.setMonomial(pos,stringToInt(copia)*pow(x,stringToInt(copia2)));
        }

        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            c=getc(f);
    }
    if(eofFound)
        ungetc(c,f);
    return res;
}
monomial evaluatePolynomY(FILE * f,double y){
    char c=getc(f);
    monomial res;
    int pos;
    if(c==EOF){
        res.setFlag(NULL);
        return res;
    }
    bool found = false;
    bool found2 = false;
    bool eolFound = false;
    bool nextMonomial = false;
    bool eofFound = false;
    bool hasX = false;
    bool hasY = false;
    int i=0;
    char copia[256];
    char copia2[256];
    char copia3[256];
    while(!eolFound && !eofFound){
        i=0;
        found = false;
        found2 = false;
        eolFound = false;
        nextMonomial = false;
        hasX=false;
        hasY=false;
        while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
            if(isNumber(c)){
                copia[i]=c;
                i++;
                c=getc(f);
            }
        }
        copia[i]='\0';
        if(!isVar(c)){
           found=true;
        }
        if(found){
           res.setIndependent(stringToInt(copia));
        }
        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            nextMonomial=true;
        if(c==EOF)
            eofFound = true;
        i=0;
        if(c=='X'){
            c=getc(f);
            hasX=true;
            if(isSquare(c)){
                c=getc(f);
                while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
                  if(isNumber(c)){
                     copia2[i]=c;
                     i++;
                     c=getc(f);
                  }
               }
           }
        }
        copia2[i]='\0';
        pos=stringToInt(copia2)-1;
       // copia2[i]='\0';
        if(!isVar(c) && !eolFound && !nextMonomial && !eofFound){
            found2 = true;
        }
        if(found2){
            res.setMonomial(pos,stringToInt(copia));
        }
        i=0;
        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            nextMonomial=true;
        if(c==EOF)
            eofFound = true;
        if(c=='Y'){
            c=getc(f);
            hasY= true;
            if(isSquare(c)){
                c=getc(f);
                while(!isVar(c) && !isAdd(c) && c!='\n' && c!=EOF){
                  if(isNumber(c)){
                     copia3[i]=c;
                     i++;
                     c=getc(f);
                  }
               }
           }
        }

        copia3[i]='\0';
        if(c==EOF)
            eofFound = true;
        if(!hasX && hasY && !eolFound && !nextMonomial){
            res.setIndependent(stringToInt(copia)*pow(y,stringToInt(copia3)));
        }
        else if (hasX && hasY && !found2 && !eolFound && !nextMonomial){
            res.setMonomial(pos,stringToInt(copia)*pow(y,stringToInt(copia3)));
        }

        if(c=='\n')
            eolFound=true;
        if(isAdd(c))
            c=getc(f);
    }
    if(eofFound)
        ungetc(c,f);
    return res;
}

char * getGraphLine(FILE *f)     /* read a line with error checking */
/* includes \n (if present) and \0.  Immediate EOF causes NULL return. */
{

        int c;
        long i;
        char s [100000];

        i = 0;
        while ((c = getc(f)) != EOF && c != '\n')
        {

            s[i++] = c;

        }

        if (i == 0 && c == EOF) return NULL;

        if (c == '\n') s[i++] = '\n';
        s[i] = '\0';

        return s;
}
double stringToDouble (char * s){
    int i=0;
    bool hasDot = false;
    bool hasNeg = false;
    int count1 = 1;
    int count2 = 1;
    int j,value;
    double dotMark=0;
    double res=0;
    double res2=0;
    while(s[i]!='\0'){
        if(s[i]=='.'){
            hasDot=true;
            dotMark = i;
        }
        i++;
    }
    if (!hasDot){
        dotMark = i;
    }
    for (j=i;j>0;j--){
        if(j!=1){
            if(j-1>dotMark){
                value = s[j-1] - '0';
                res2 = res2 + value*count2;
                count2 = count2*10;
            }
            else if(j-1<dotMark){
                value = s[j-1] - '0';
                res = res + value*count1;
                count1 = count1*10;
            }
        }
        else{
            if(s[j-1]!='-'){
                value = s[j-1] - '0';
                res = res + value*count1;
                count1 = count1*10;
            }
            else{
                hasNeg = true;
            }
        }
    }

    res2 = res2 / (count2);
    res = res + res2;
    if(hasNeg)
        res=res*(-1);

    return res;
}
